/*------------------------------------------------------------------------
Door.cpp: implementation of the CDoor class.
DroidWars Video Game - version 0.1

    Copyright (C) 2000 Thad D. Phetteplace

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Examine the license.txt file located in the main source code directory
    to see the full text of the GPL license document.

    Direct inquiries to:    The GridSlammer Project
                            P.O. Box 26354
                            Wauwatosa, WI 53208

    Or on the Internet at:    http://www.gridslammer.org
                            info@gridslammer.org
------------------------------------------------------------------------*/

#include "Door.h"



CDoor::CDoor()
{
    Initialize();
}



CDoor::~CDoor()
{
}



void CDoor::Initialize( void )
{
    CGridObj::Initialize();
    m_DoorStatus = 1;
    m_KeyNum = 0;
}




int CDoor::Render(CGridView *gv, unsigned long lClockTicks,
    int nScreenX, int nScreenY)
{
    if (m_PicNum == 25) {
        if (m_DoorStatus < -400) {
            int yoffs = 8 - (500 + m_DoorStatus) * 33 / 100;
            gv->DrawPic( m_PicNum, nScreenX, nScreenY-yoffs);
        }
        else if (m_DoorStatus < 0 && m_DoorStatus > -100) {
            int yoffs = 8 - (m_DoorStatus) * -33 / 100;
            gv->DrawPic( m_PicNum, nScreenX, nScreenY-yoffs);
        }
        else if (m_DoorStatus >= 0) {
            gv->DrawPic( m_PicNum, nScreenX, nScreenY-8);
        }
    }
    else if (m_DoorStatus > 0) {
        gv->DrawPic( m_PicNum, nScreenX, nScreenY-25);
    }

    return 0;
}





int CDoor::Process(unsigned long lClockTicks, double dTimeSlice)
{
    if (m_PicNum == 25) {
        if (m_DoorStatus <= 0) {
            if (m_DoorStatus < -400 || m_DoorStatus >= -100) {
                m_Solid = 1;
            }
            else if (m_DoorStatus < -100) {
                m_Solid = 0;
            }
            m_DoorStatus++;
        }
        if (!m_DoorStatus) m_Solid = 1;
    }
    else {
        if (m_DoorStatus <= 0) {
            m_DoorStatus++;
            if (m_DoorStatus >= 0) m_Solid = 1;
            else m_Solid = 0;
        }
    }
    RemoveObjFromSquare();
    AddObjToSquare();
    return 0;
}





void CDoor::MoveDoor( int nPos )
{
    CDoor* p = this;

    if (m_DoorStatus < 0) return;

    while (p->m_DoorStatus != nPos) {
        p->m_DoorStatus = nPos;
        //if (nPos <= 0) p->m_Solid = 0;
        p = p->m_NextDoor;
    }
}
