/*------------------------------------------------------------------------
Droid.h: interface for the CDroid class.
DroidWars Video Game - version 0.1

    Copyright (C) 2000 Thad D. Phetteplace

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Examine the license.txt file located in the main source code directory
    to see the full text of the GPL license document.

    Direct inquiries to:    The GridSlammer Project
                            P.O. Box 26354
                            Wauwatosa, WI 53208

    Or on the Internet at:    http://www.gridslammer.org
                            info@gridslammer.org
------------------------------------------------------------------------*/

#if !defined(DROID_H_INCLUDED)
#define DROID_H_INCLUDED

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "GridSlammer/GridActor.h"

#define MAX_KEYS          20


class CDroid : public CGridActor  
{
public:
    CDroid();
    virtual ~CDroid();
    void Initialize( void );
    virtual int Render(CGridView *gv, unsigned long lClockTicks,
        int nScreenX, int nScreenY);
    virtual int Process(unsigned long lClockTicks, double dTimeSlice);
    CDroid* RadarSweep( double dDistance );
    int ChangeArmor( int nChange );
    void FireWeapon( int nGun );
    void ChangeSpeed( double change );
    void ChangeHeat( int change );
    void AddKey( int keynum );
    int  TryKeys( int locknum );

    double m_TurretDir;
    int    m_TurretViews;
    int    m_TurretHeight;
    int    m_TurretPicNum;
    int    m_Armor;
    int    m_Ammo;
    int    m_Fuel;
    int    m_Heat;
    int    m_MaxArmor;
    int    m_MaxAmmo;
    int    m_MaxFuel;
    int    m_MaxHeat;
    double m_MaxSpeed;
    int    m_WeaponRecharge;
    int    m_WeaponStatus;
    int    m_HeatSink;
    int    m_KeyList[MAX_KEYS];
    int    m_KeyCount;

    GPic*  m_ArmorPic;
    GPic*  m_AmmoPic;
    GPic*  m_FuelPic;
    GPic*  m_HeatPic;
};

#endif // !defined(DROID_H_INCLUDED)
