/*------------------------------------------------------------------------
DroidwarStage.cpp: implementation of the CDroidwarStage class
------------------------------------------------------------------------*/
#include "DroidStage.h"
#include <stdio.h>
#include <stdlib.h>
#include "Droid.h"
#include "Door.h"
#include "Bullet.h"
#include <string.h>
#include <ctype.h>



CDroidStage::CDroidStage()
{
}



CDroidStage::~CDroidStage()
{
}





int CDroidStage::Render( CGridView *gv )
{
    if (m_Ticks < 500 ) DrawConsole(gv);
    gv->SetTicks(m_Ticks);  // this is a kludge!  -TDP

    DrawBackground(gv);

    // set the perspective to the first object in the list
    if (m_Objects[0]->m_Team == 1) {
        m_xpos = m_Objects[0]->m_XPos;
        m_ypos = m_Objects[0]->m_YPos;
    }

    RenderGrid( gv, m_xpos + 13.0, m_ypos - 0.5);

    //if (!(rand()%200)) SDL_Delay(500);

    // Is the game over?
    if (m_Objects[0]->m_Team != 1) {
        gv->DrawPic( 29, 180,190);
    }

    // Update bargraphs and such
    gv->DrawConsolePic( 24, 82, 417 );
    gv->DrawConsolePic( 26, 82, 431 );
    gv->DrawConsolePic( 27, 82, 445 );
    gv->DrawConsolePic( 28, 82, 459 );

    // Update the text console
    gv->DrawString( 345, 425, "0123456789:;<=>? !#$%&()*+,-." );
    gv->DrawString( 345, 440, "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_" );
    gv->DrawString( 345, 455, "`abcdefghijklmnopqrstuvwxyz{|}~ " );

    //SDL_Delay(30); // DELETE ME! -TDP
    gv->FlipSurface();

    return 0;
}






void CDroidStage::DrawConsole( CGridView *gv )
{
    gv->DrawConsolePic( 22, 0, 400);
}





int CDroidStage::LoadGrid( char *filename, GGridInfo *gridinfo )
{
    FILE *fh;
    int x = 0;
    int k;
    int y = MAX_Y_GRID_SIZE-1;
    char buf[MAX_X_GRID_SIZE*2+100];
    char flag[MAX_X_GRID_SIZE*2+100];
    CDroid* TempDroid;
    CDoor *TempDoor, *PrevDoor, *FirstDoor;
    CGridObj *TempObj;
    int objtype, team, picnum, value, yoffs;
    float xpos, ypos, diam;

    for (x=0; x<MAX_X_GRID_SIZE; x++) {
        for (y=0; y<MAX_Y_GRID_SIZE; y++) {
            // create an AssignGridTerrain method! -TDP
            m_Grid[((int)(x))+((int)(y))*m_GridXSize] = 0;
        }
    }

    fh = fopen( filename, "rt" );
    if (!fh) return 1;

    y = MAX_Y_GRID_SIZE-1;

    // Skip lines until we find the grid
    do {
        fgets( buf, MAX_X_GRID_SIZE*2+99, fh);
    } while (!feof(fh) && strncmp("G>", buf, 2));

    // Read in the grid
    while (!feof(fh) && y>=0) {
        x = 0;
        while (buf[x+2] && buf[x+3] && x<MAX_X_GRID_SIZE) {
            if (buf[x+2] == '.') {
                m_Grid[((int)(x))+((int)(y))*m_GridXSize] = 0;
            }
            else if (buf[x+2] == 'X') {
                m_Grid[((int)(x))+((int)(y))*m_GridXSize] = 25;
            }
            else if (buf[x+2] == '#') {
                m_Grid[((int)(x))+((int)(y))*m_GridXSize] = 47;
            }
            else if (isdigit(buf[x+2])) {
                m_Grid[((int)(x))+((int)(y))*m_GridXSize] = buf[x+2] - '0';
            }
            x++;
        }
        fgets( buf, MAX_X_GRID_SIZE*2+99, fh);
        y--;
    }

    // Read in the objects
    while (!feof(fh) && buf[0] != '.') {
        if (!strncmp(buf, "!obj:", 5)) {
            // Read in an individual object
            switch(atoi(buf+5)) {
            case OT_TANK:
                TempDroid = new CDroid();
                sscanf( buf+5, "%d %d %f %f %d",
                    &objtype, &team, &xpos, &ypos, &picnum );
                TempDroid->m_ObjType = objtype;
                TempDroid->m_Team = team;
                TempDroid->m_XPos = (double) xpos;
                TempDroid->m_YPos = (double) ypos;
                TempDroid->m_Speed = 0.05;
                TempDroid->m_Diameter = 1.0;
                TempDroid->m_Radius = 0.5;
                TempDroid->m_PicNum = picnum;
                TempDroid->ConnectToGrid(gridinfo);
                //if (team == 1) MyDroid = TempDroid;
                break;
            case OT_DOOR:
                k=0;
                sscanf( buf+5, "%d %d %d", &objtype, &team, &value );
                do {
                    fgets( buf, MAX_X_GRID_SIZE*2+99, fh);
                    if (buf[0] != '#') {
                        sscanf( buf, "%f %f %f %d %s",
                            &xpos, &ypos, &diam, &picnum, flag );
                        TempDoor = new CDoor();
                        TempDoor->m_ObjType = OT_DOOR;
                        TempDoor->m_XPos = xpos;
                        TempDoor->m_YPos = ypos;
                        TempDoor->m_Diameter = diam;
                        TempDoor->m_Radius = diam / 2.0;
                        TempDoor->m_PicNum = picnum;
                        TempDoor->m_Value = value;
                        if (k==0) {
                            FirstDoor = TempDoor;
                        }
                        else {
                            TempDoor->m_NextDoor = PrevDoor;
                        }
                        PrevDoor = TempDoor;
                        TempDoor->ConnectToGrid(gridinfo);
                        k++;
                    }
                } while (!feof(fh) && flag[0] != '.');
                FirstDoor->m_NextDoor = TempDoor;
                break;
            case OT_KEY:
            case OT_FUEL:
            case OT_AMMO:
            case OT_ARMOR:
                TempObj = new CGridObj();
                sscanf( buf+5, "%d %d %d %f %f %f %d %d",
                    &objtype, &team, &value, &xpos, &ypos, &diam, &picnum, &yoffs );
                TempObj->m_ObjType = objtype;
                TempObj->m_Team = team;
                TempObj->m_XPos = xpos,
                TempObj->m_YPos = ypos;
                TempObj->m_YOffset = yoffs;
                TempObj->m_Diameter = diam;
                TempObj->m_Radius = diam / 2.0;
                TempObj->m_PicNum = picnum;
                TempObj->m_Value = value;
                TempObj->ConnectToGrid(gridinfo);
                break;
            }
        }
        fgets( buf, MAX_X_GRID_SIZE*2+99, fh);
    }

    return 0;
}

