/*------------------------------------------------------------------------
GridMenu.cpp
GridSlammer Game Engine - version 0.1

    Copyright (C) 2000 Thad D. Phetteplace

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Examine the license.txt file located in the GridSlammer directory
    to see the full text of the LGPL license document.

    Direct inquiries to:    The GridSlammer Project
                            P.O. Box 26354
                            Wauwatosa, WI 53208

    Or on the Internet at:    http://www.gridslammer.org
                            info@gridslammer.org

------------------------------------------------------------------------*/

#include "GridMenu.h"


CGridMenu::CGridMenu()
{
    m_nIsActive = 0;
    m_nMenuPos = 0;
}



CGridMenu::~CGridMenu()
{
}



void CGridMenu::Open( CGridView *gv )
{
    m_GridView = gv;
    m_nIsActive = 1;
}



void CGridMenu::Close( void )
{
    m_nIsActive = 0;
}



int  CGridMenu::IsActive( void )
{
    return m_nIsActive;
}



void CGridMenu::ArrowUp( void )
{
    m_nMenuPos--;
    if (m_nMenuPos < 0) m_nMenuPos = 5;
}



void CGridMenu::ArrowDown( void )
{
    m_nMenuPos++;
    if (m_nMenuPos > 5) m_nMenuPos = 0;
}



int CGridMenu::Select( void )
{
    return m_nMenuPos;
}



void CGridMenu::Render( void )
{
    int x, y;
    int top=59, left=142;
    int bottom=389, right=502;

    // this box code should be moved into a new function! -TDP
    for (x=left; x<right-12; x+=20) {
        m_GridView->DrawPic( 34, x, top-12);
        m_GridView->DrawPic( 34, x, bottom);
    }
    for (y=top; y<bottom-10; y+=20) {
        m_GridView->DrawPic( 33, left-12, y);
        m_GridView->DrawPic( 33, right, y);
    }
    m_GridView->DrawPic( 35, left-12, top-12);
    m_GridView->DrawPic( 36, right, top-12);
    m_GridView->DrawPic( 37, right, bottom);
    m_GridView->DrawPic( 38, left-12, bottom);
    m_GridView->ClearBox(left, top, right, bottom);

    m_GridView->DrawString( 250, 80, "M A I N    M E N U");
    m_GridView->DrawString( 180, 100, "--------------------------------------");

    m_GridView->DrawString( 250, 140, "1. Start New Game");
    m_GridView->DrawString( 250, 180, "2. Load a Game");
    m_GridView->DrawString( 250, 220, "3. Save Current Game");
    m_GridView->DrawString( 250, 260, "4. Change Settings");
    m_GridView->DrawString( 250, 300, "5. Read On-line Help");
    m_GridView->DrawString( 250, 340, "6. Exit the Game");


    m_GridView->DrawString( 210, 140 + m_nMenuPos*40, "--->");
    m_GridView->DrawString( 410, 140 + m_nMenuPos*40, "<---");

    m_GridView->FlipSurface();
}



