/*------------------------------------------------------------------------
GridActor.h: interface for the CGridActor class.
GridSlammer Game Engine - version 0.1

    Copyright (C) 2000 Thad D. Phetteplace

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Examine the license.txt file located in the GridSlammer directory
    to see the full text of the LGPL license document.

    Direct inquiries to:    The GridSlammer Project
                            P.O. Box 26354
                            Wauwatosa, WI 53208

    Or on the Internet at:    http://www.gridslammer.org
                            info@gridslammer.org
------------------------------------------------------------------------*/

#if !defined(GRIDACTOR_H_INCLUDED)
#define GRIDACTOR_H_INCLUDED

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "GridObj.h"

class CGridActor : public CGridObj  
{
public:
    CGridActor();
    CGridActor(GGridInfo *Info);
 
    void Initialize( void );
    virtual ~CGridActor();
    virtual int Render(CGridView *gv, unsigned long lClockTicks,
        int nScreenX, int nScreenY);
    virtual int Process(unsigned long lClockTicks, double dTimeSlice);
    void ChangeDirection( double change );
    void ChangeSpeed( double change );
    inline double CalcXSpeed( double dSpeed, double dDirection ) { return dSpeed * cos( dDirection ); };
    inline double CalcYSpeed( double dSpeed, double dDirection ) { return dSpeed * sin( dDirection ); };
    inline double CalcDirection( double dXSpeed, double dYSpeed ) { return atan2(dYSpeed, dXSpeed); };

    int    m_Views;
    double m_Speed;
    double m_XSpeed;
    double m_YSpeed;
    double m_Direction;
    int    m_LifeSpan;
};


#endif // !defined(GRIDACTOR_H_INCLUDED)
