/*------------------------------------------------------------------------
GridTile.h: interface for the CGridTile class.
GridSlammer Game Engine - version 0.1

    Copyright (C) 2000 Thad D. Phetteplace

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Examine the license.txt file located in the GridSlammer directory
    to see the full text of the LGPL license document.

    Direct inquiries to:    The GridSlammer Project
                            P.O. Box 26354
                            Wauwatosa, WI 53208

    Or on the Internet at:    http://www.gridslammer.org
                            info@gridslammer.org
------------------------------------------------------------------------*/

#if !defined(GRIDTILE_H_INCLUDED)
#define GRIDTILE_H_INCLUDED

#include <math.h>
#include "GridView.h"

#define GRID(x,y)      m_Grid[((int)(x))+((int)(y))*m_GridXSize]
#define GRIDOBJS(x,y)  m_GridObjs[((int)(x))+((int)(y))*m_GridXSize]


class CGridTile
{
public:
    CGridTile();

    CGridTile(GGridInfo *Info);
    virtual ~CGridTile();
    virtual int Render(CGridView *gv, unsigned long lClockTicks,
        int nScreenX, int nScreenY);
    int DrawCursor(CGridView *gv, unsigned long lClockTicks,
        int nScreenX, int nScreenY, int nMouseX, int nMouseY);
    int CollisionCheck( double nXpos, double nYpos );

    int    m_TileNum;
    int    m_PicNum;
    int    m_Height;
    int    m_Solid;
    int    m_TileCursorPic;
    int    m_MouseCursorPic;
    int    m_XCursorOffset;
    int    m_YCursorOffset;

};

#endif // !defined(GRIDTILE_H_INCLUDED)
